//===================================
// Copyright Yakibomb
//===================================

function VSCONDS_COMPILE_CONDITIONS() {
	foreach ( cond, value in ROOT )
	{
		if (typeof(value) == "class" && startswith(cond, "VS_COND_"))
		{
			if ( cond in ROOT ) delete ROOT[cond];
			VSCOND_COND_NAMES.append(cond);
			local cond_num = VSCOND_COND_NAMES.len() - 1;
			
			ROOT[cond] <- cond_num;
			
			local internalCondsName = "FUNC_" + cond;
			ROOT[internalCondsName] <- { condition = cond_num };
			VSCOND_COND_FUNC.append(ROOT[internalCondsName]);
					
		//	ClientPrint(null,3,VSCOND_COND_NAMES[cond_num].tostring() + " | " + cond_num )
			
			local base_function_think = VSConds_Base["Think"];
			
			foreach ( key, kv in value )
			{
				if ( key == "condition" ) continue
				
				if ( key == "Think" ) {
					if ( kv != base_function_think ) {
						ROOT[internalCondsName]["use_think_script"] <- true;
					}
					else 
						ROOT[internalCondsName]["use_think_script"] <- false;
				}
				
				ROOT[internalCondsName][key] <- kv;
			}
		//Sets up condition states
		//states are in vsconds_constants.nut
			local condition_function = ROOT[internalCondsName]
			local bits = 0;
			foreach ( key, kv in condition_function )
			{
				if ( key == "removedByDeath"
				  && kv == true )
					bits += VSCONDS_BASE_REMOVEABLE_BY_DEATH;
				else if ( key == "removedByResupply"
				  && kv == true )
					bits += VSCONDS_BASE_REMOVEABLE_BY_RESUPPLY;
				else if ( key == "removedByTeamChange"
				  && kv == true )
					bits += VSCONDS_BASE_REMOVEABLE_BY_TEAMCHANGE;
				else if ( key == "removedByClassChange"
				  && kv == true )
					bits += VSCONDS_BASE_REMOVEABLE_BY_CLASSCHANGE;
				else if ( key == "removedByCommand"
				  && kv == true )
					bits += VSCONDS_BASE_REMOVEABLE_BY_COMMAND;
			}
			ROOT[internalCondsName]["settingsBits"] <- bits;
		// end condition states setup
		}
	}
}